Index: trunk/autoquest-plugin-uml-test/src/test/resources/ita_model.uml
===================================================================
--- trunk/autoquest-plugin-uml-test/src/test/resources/ita_model_v2.uml	(revision 1926)
+++ trunk/autoquest-plugin-uml-test/src/test/resources/ita_model.uml	(revision 1927)
@@ -13,20 +13,20 @@
         <ownedParameter xmi:type="uml:Parameter" xmi:id="_ov6xYMZjEeSM37Q-L6-vug" name="purchaseOrderConfirmationXML" type="_zUagUMZiEeSM37Q-L6-vug"/>
       </ownedOperation>
-      <ownedOperation xmi:type="uml:Operation" xmi:id="_vgWjYMZjEeSM37Q-L6-vug" name="FinalPurchaseOrderNotification">
+      <ownedOperation xmi:type="uml:Operation" xmi:id="_vgWjYMZjEeSM37Q-L6-vug" name="finalPurchaseOrderStatusNotification">
         <ownedParameter xmi:type="uml:Parameter" xmi:id="_yh9TMMZjEeSM37Q-L6-vug" name="finalPurchaseOrderNotificationXML" type="_zUagUMZiEeSM37Q-L6-vug"/>
       </ownedOperation>
-      <ownedOperation xmi:type="uml:Operation" xmi:id="_0vorsMZjEeSM37Q-L6-vug" name="InstrutionToReceive">
+      <ownedOperation xmi:type="uml:Operation" xmi:id="_0vorsMZjEeSM37Q-L6-vug" name="instrutionToReceive">
         <ownedParameter xmi:type="uml:Parameter" xmi:id="_26sOAMZjEeSM37Q-L6-vug" name="warehousingInboundInstructionXML" type="_BKBlQMZjEeSM37Q-L6-vug"/>
       </ownedOperation>
-      <ownedOperation xmi:type="uml:Operation" xmi:id="_5DzPkMZjEeSM37Q-L6-vug" name="DropOffRequest">
+      <ownedOperation xmi:type="uml:Operation" xmi:id="_5DzPkMZjEeSM37Q-L6-vug" name="dropOffRequest">
         <ownedParameter xmi:type="uml:Parameter" xmi:id="_7KdaEMZjEeSM37Q-L6-vug" name="transportPickUpDropOffRequestXML" type="_J2tokMZjEeSM37Q-L6-vug"/>
       </ownedOperation>
-      <ownedOperation xmi:type="uml:Operation" xmi:id="_8tvxwMZjEeSM37Q-L6-vug" name="DepatchNotificationInbound">
+      <ownedOperation xmi:type="uml:Operation" xmi:id="_8tvxwMZjEeSM37Q-L6-vug" name="depatchNotificationInbound">
         <ownedParameter xmi:type="uml:Parameter" xmi:id="__QcYAMZjEeSM37Q-L6-vug" name="despatchAdviceXML" type="_52mp4MGfEeSgpOzAzVFJPA"/>
       </ownedOperation>
-      <ownedOperation xmi:type="uml:Operation" xmi:id="_BAs0sMZkEeSM37Q-L6-vug" name="InboudDeliveryStatus">
+      <ownedOperation xmi:type="uml:Operation" xmi:id="_BAs0sMZkEeSM37Q-L6-vug" name="inboudDeliveryStatus">
         <ownedParameter xmi:type="uml:Parameter" xmi:id="_DKsnEMZkEeSM37Q-L6-vug" name="receivingAdviceXML" type="_byn0gMZjEeSM37Q-L6-vug"/>
       </ownedOperation>
-      <ownedOperation xmi:type="uml:Operation" xmi:id="_E_lsIMZkEeSM37Q-L6-vug" name="ProductSold">
+      <ownedOperation xmi:type="uml:Operation" xmi:id="_E_lsIMZkEeSM37Q-L6-vug" name="productSold">
         <ownedParameter xmi:type="uml:Parameter" xmi:id="_HQvPYMZkEeSM37Q-L6-vug" name="idProduct">
           <type xmi:type="uml:PrimitiveType" href="pathmap://UML_LIBRARIES/UMLPrimitiveTypes.library.uml#String"/>
@@ -38,40 +38,40 @@
     </packagedElement>
     <packagedElement xmi:type="uml:Interface" xmi:id="_v3NckLEMEeSnYZTmeJXZKg" name="WarehouseInterface">
-      <ownedOperation xmi:type="uml:Operation" xmi:id="_MJZf0LENEeSnYZTmeJXZKg" name="InstrutionToReceive">
+      <ownedOperation xmi:type="uml:Operation" xmi:id="_MJZf0LENEeSnYZTmeJXZKg" name="instrutionToReceive">
         <ownedParameter xmi:type="uml:Parameter" xmi:id="_1yASMMZkEeSM37Q-L6-vug" name="warehousingInboundInstructionXML" type="_BKBlQMZjEeSM37Q-L6-vug"/>
       </ownedOperation>
-      <ownedOperation xmi:type="uml:Operation" xmi:id="_59PjkMZkEeSM37Q-L6-vug" name="DepatchNotificationInbound">
+      <ownedOperation xmi:type="uml:Operation" xmi:id="_59PjkMZkEeSM37Q-L6-vug" name="depatchNotificationInbound">
         <ownedParameter xmi:type="uml:Parameter" xmi:id="_8A3BIMZkEeSM37Q-L6-vug" name="despatchAdviceXML" type="_52mp4MGfEeSgpOzAzVFJPA"/>
       </ownedOperation>
-      <ownedOperation xmi:type="uml:Operation" xmi:id="_9owMAMZkEeSM37Q-L6-vug" name="InboudDeliveryStatus">
+      <ownedOperation xmi:type="uml:Operation" xmi:id="_9owMAMZkEeSM37Q-L6-vug" name="inboudDeliveryStatus">
         <ownedParameter xmi:type="uml:Parameter" xmi:id="__8kowMZkEeSM37Q-L6-vug" name="receivingAdviceXML" type="_byn0gMZjEeSM37Q-L6-vug"/>
       </ownedOperation>
-      <ownedOperation xmi:type="uml:Operation" xmi:id="_Bcs-wMZlEeSM37Q-L6-vug" name="OutboundDeliveryStatus">
+      <ownedOperation xmi:type="uml:Operation" xmi:id="_Bcs-wMZlEeSM37Q-L6-vug" name="outboundDeliveryStatus">
         <ownedParameter xmi:type="uml:Parameter" xmi:id="_DqPNUMZlEeSM37Q-L6-vug" name="warehousingOutboundNotificationXML" type="_S6YMAMZkEeSM37Q-L6-vug"/>
       </ownedOperation>
-      <ownedOperation xmi:type="uml:Operation" xmi:id="_Fpvm8MZlEeSM37Q-L6-vug" name="InventoryStatusInstrution">
+      <ownedOperation xmi:type="uml:Operation" xmi:id="_Fpvm8MZlEeSM37Q-L6-vug" name="inventoryStatusInstruction">
         <ownedParameter xmi:type="uml:Parameter" xmi:id="_H0BtMMZlEeSM37Q-L6-vug" name="inventoryReportStatusXML" type="_a0lCcMZkEeSM37Q-L6-vug"/>
       </ownedOperation>
-      <ownedOperation xmi:type="uml:Operation" xmi:id="_JqanEMZlEeSM37Q-L6-vug" name="ReceiptNotificationOutBound">
+      <ownedOperation xmi:type="uml:Operation" xmi:id="_JqanEMZlEeSM37Q-L6-vug" name="receiptNotificationOutBound">
         <ownedParameter xmi:type="uml:Parameter" xmi:id="_L4tDkMZlEeSM37Q-L6-vug" name="receivingAdviceXML" type="_VuelIMGfEeSgpOzAzVFJPA"/>
       </ownedOperation>
-      <ownedOperation xmi:type="uml:Operation" xmi:id="_NFql8MZlEeSM37Q-L6-vug" name="InstructionToDespatch">
+      <ownedOperation xmi:type="uml:Operation" xmi:id="_NFql8MZlEeSM37Q-L6-vug" name="instructionToDespatch">
         <ownedParameter xmi:type="uml:Parameter" xmi:id="_PDEt0MZlEeSM37Q-L6-vug" name="warehousingOutboundInstructionXML" type="_gxWi4MZkEeSM37Q-L6-vug"/>
       </ownedOperation>
-      <ownedOperation xmi:type="uml:Operation" xmi:id="_QhrZ0MZlEeSM37Q-L6-vug" name="PickUpRequest">
+      <ownedOperation xmi:type="uml:Operation" xmi:id="_QhrZ0MZlEeSM37Q-L6-vug" name="pickUpRequest">
         <ownedParameter xmi:type="uml:Parameter" xmi:id="_TIxX4MZlEeSM37Q-L6-vug" name="transportPickUpDropOffRequestXML" type="_J2tokMZjEeSM37Q-L6-vug"/>
       </ownedOperation>
     </packagedElement>
     <packagedElement xmi:type="uml:Interface" xmi:id="_wimi8LEMEeSnYZTmeJXZKg" name="TransportInterface">
-      <ownedOperation xmi:type="uml:Operation" xmi:id="_CMyFsLENEeSnYZTmeJXZKg" name="DropOffConfirmationRequest">
+      <ownedOperation xmi:type="uml:Operation" xmi:id="_CMyFsLENEeSnYZTmeJXZKg" name="dropOffConfirmation">
         <ownedParameter xmi:type="uml:Parameter" xmi:id="_G9ATcLENEeSnYZTmeJXZKg" name="TransportPickUpDropOffConfirmationXML" type="_udxaIMZlEeSM37Q-L6-vug"/>
       </ownedOperation>
-      <ownedOperation xmi:type="uml:Operation" xmi:id="_OQV-MLENEeSnYZTmeJXZKg" name="PickUpConfirmationRequest">
+      <ownedOperation xmi:type="uml:Operation" xmi:id="_OQV-MLENEeSnYZTmeJXZKg" name="pickUpConfirmation">
         <ownedParameter xmi:type="uml:Parameter" xmi:id="_OQV-MbENEeSnYZTmeJXZKg" name="transportPickUpDropOffConfirmationXML" type="_udxaIMZlEeSM37Q-L6-vug"/>
       </ownedOperation>
-      <ownedOperation xmi:type="uml:Operation" xmi:id="_YGXBELENEeSnYZTmeJXZKg" name="transportInstructionRequest">
+      <ownedOperation xmi:type="uml:Operation" xmi:id="_YGXBELENEeSnYZTmeJXZKg" name="transportInstruction">
         <ownedParameter xmi:type="uml:Parameter" xmi:id="_bH9J0LENEeSnYZTmeJXZKg" name="transportInstructionXML" type="_lF2ogMZlEeSM37Q-L6-vug"/>
       </ownedOperation>
-      <ownedOperation xmi:type="uml:Operation" xmi:id="_7U8ykMcCEeSZe4KIZH8Y5w" name="TransportStatusRequest">
+      <ownedOperation xmi:type="uml:Operation" xmi:id="_7U8ykMcCEeSZe4KIZH8Y5w" name="transportStatusRequest">
         <ownedParameter xmi:type="uml:Parameter" xmi:id="_-h5PsMcCEeSZe4KIZH8Y5w" name="transportStatusRequestXML" type="_2q8P4MZlEeSM37Q-L6-vug"/>
         <ownedParameter xmi:type="uml:Parameter" xmi:id="_BaVccMcDEeSZe4KIZH8Y5w" name="TransportStatusResponse" type="_mYGNUMGgEeSgpOzAzVFJPA" direction="out"/>
@@ -79,23 +79,23 @@
     </packagedElement>
     <packagedElement xmi:type="uml:Interface" xmi:id="_xI2DkLEMEeSnYZTmeJXZKg" name="MaterialSupplierInterface">
-      <ownedOperation xmi:type="uml:Operation" xmi:id="_zLZgsMGgEeSgpOzAzVFJPA" name="ReceiptNotificationInbound">
+      <ownedOperation xmi:type="uml:Operation" xmi:id="_zLZgsMGgEeSgpOzAzVFJPA" name="receiptNotificationInbound">
         <ownedParameter xmi:type="uml:Parameter" xmi:id="_8bhBMMGgEeSgpOzAzVFJPA" name="receivingAdviceXML" type="_VuelIMGfEeSgpOzAzVFJPA"/>
       </ownedOperation>
-      <ownedOperation xmi:type="uml:Operation" xmi:id="_AgddUMGhEeSgpOzAzVFJPA" name="InventoryReport">
+      <ownedOperation xmi:type="uml:Operation" xmi:id="_AgddUMGhEeSgpOzAzVFJPA" name="inventoryReport">
         <ownedParameter xmi:type="uml:Parameter" xmi:id="_Dzy2UMGhEeSgpOzAzVFJPA" name="inventoryActivityXML" type="_w4wlIMGfEeSgpOzAzVFJPA"/>
       </ownedOperation>
-      <ownedOperation xmi:type="uml:Operation" xmi:id="_FHJUkMGhEeSgpOzAzVFJPA" name="DespatchNotificationOutbound">
+      <ownedOperation xmi:type="uml:Operation" xmi:id="_FHJUkMGhEeSgpOzAzVFJPA" name="despatchNotificationOutbound">
         <ownedParameter xmi:type="uml:Parameter" xmi:id="_IEQl8MGhEeSgpOzAzVFJPA" name="DespatchAdviceXML" type="_52mp4MGfEeSgpOzAzVFJPA"/>
       </ownedOperation>
-      <ownedOperation xmi:type="uml:Operation" xmi:id="_JZ_p0MGhEeSgpOzAzVFJPA" name="PurchaseOrder">
+      <ownedOperation xmi:type="uml:Operation" xmi:id="_JZ_p0MGhEeSgpOzAzVFJPA" name="purchaseOrder">
         <ownedParameter xmi:type="uml:Parameter" xmi:id="_MQ0F8MGhEeSgpOzAzVFJPA" name="purchaseOrderXML" type="_YsJasMGgEeSgpOzAzVFJPA"/>
       </ownedOperation>
-      <ownedOperation xmi:type="uml:Operation" xmi:id="_Nt_OkMGhEeSgpOzAzVFJPA" name="TransportInstructionConfirmation">
+      <ownedOperation xmi:type="uml:Operation" xmi:id="_Nt_OkMGhEeSgpOzAzVFJPA" name="transportInstructionConfirmation">
         <ownedParameter xmi:type="uml:Parameter" xmi:id="_QGq9MMGhEeSgpOzAzVFJPA" name="transportInstructionResponseXML" type="_ePz3kMGgEeSgpOzAzVFJPA"/>
       </ownedOperation>
-      <ownedOperation xmi:type="uml:Operation" xmi:id="_RnLtsMGhEeSgpOzAzVFJPA" name="TransporStatusNotification">
+      <ownedOperation xmi:type="uml:Operation" xmi:id="_RnLtsMGhEeSgpOzAzVFJPA" name="transporStatusNotification">
         <ownedParameter xmi:type="uml:Parameter" xmi:id="_UFNPUMGhEeSgpOzAzVFJPA" name="transportStatusNotificationXML" type="_mYGNUMGgEeSgpOzAzVFJPA"/>
       </ownedOperation>
-      <ownedOperation xmi:type="uml:Operation" xmi:id="_Wr1TUMGhEeSgpOzAzVFJPA" name="FinalTransportStatusNotification">
+      <ownedOperation xmi:type="uml:Operation" xmi:id="_Wr1TUMGhEeSgpOzAzVFJPA" name="finalTransportStatusNotification">
         <ownedParameter xmi:type="uml:Parameter" xmi:id="_ZCawMMGhEeSgpOzAzVFJPA" name="transportStatusNotificationXML" type="_mYGNUMGgEeSgpOzAzVFJPA"/>
       </ownedOperation>
@@ -110,11 +110,11 @@
       </ownedAttribute>
     </packagedElement>
-    <packagedElement xmi:type="uml:Component" xmi:id="_tXV18LEOEeSnYZTmeJXZKg" clientDependency="_2NfKoMfgEeSpzN7smHOlWA" name="PointOfSalePortType"/>
+    <packagedElement xmi:type="uml:Component" xmi:id="_tXV18LEOEeSnYZTmeJXZKg" clientDependency="_siE_kM1iEeSGIJvkDQlGlw" name="PointOfSalePortType"/>
     <packagedElement xmi:type="uml:Component" xmi:id="_eKs3MLEPEeSnYZTmeJXZKg" name="TransportService">
       <ownedAttribute xmi:type="uml:Port" xmi:id="_944gMLEPEeSnYZTmeJXZKg" name="transportPort" type="_o9UFMLEPEeSnYZTmeJXZKg" aggregation="composite"/>
     </packagedElement>
-    <packagedElement xmi:type="uml:Component" xmi:id="_o9UFMLEPEeSnYZTmeJXZKg" clientDependency="_2kn4QMfgEeSpzN7smHOlWA" name="TransportPortType"/>
-    <packagedElement xmi:type="uml:Component" xmi:id="_rU8q8LEPEeSnYZTmeJXZKg" clientDependency="_29TeAMfgEeSpzN7smHOlWA" name="WarehousePortType"/>
-    <packagedElement xmi:type="uml:Component" xmi:id="_tDepULEPEeSnYZTmeJXZKg" clientDependency="_3fMDEMfgEeSpzN7smHOlWA" name="MaterialSupplierPortType"/>
+    <packagedElement xmi:type="uml:Component" xmi:id="_o9UFMLEPEeSnYZTmeJXZKg" clientDependency="_0IL1UM1iEeSGIJvkDQlGlw" name="TransportPortType"/>
+    <packagedElement xmi:type="uml:Component" xmi:id="_rU8q8LEPEeSnYZTmeJXZKg" clientDependency="_05fWcM1iEeSGIJvkDQlGlw" name="WarehousePortType"/>
+    <packagedElement xmi:type="uml:Component" xmi:id="_tDepULEPEeSnYZTmeJXZKg" clientDependency="_186iUM1iEeSGIJvkDQlGlw" name="MaterialSupplierPortType"/>
     <packagedElement xmi:type="uml:Component" xmi:id="_4T50sLEPEeSnYZTmeJXZKg" name="WarehouseService">
       <ownedAttribute xmi:type="uml:Port" xmi:id="_QSCo0LEQEeSnYZTmeJXZKg" name="warehousePort" type="_rU8q8LEPEeSnYZTmeJXZKg" aggregation="composite"/>
@@ -170,4 +170,5 @@
         </end>
       </ownedConnector>
+      <ownedOperation xmi:type="uml:Operation" xmi:id="_k-fb8LHPEeS0dumc9hw2vw" name="functional_TestCase1"/>
     </packagedElement>
     <packagedElement xmi:type="uml:Component" xmi:id="_hwwbELETEeSnYZTmeJXZKg" name="Logistics_Environment">
@@ -219,4 +220,20 @@
         <subvertex xmi:type="uml:State" xmi:id="_FwmnMMcFEeSZe4KIZH8Y5w" name="StatePickUpDropOffConfirmed"/>
       </region>
+    </packagedElement>
+    <packagedElement xmi:type="uml:Interaction" xmi:id="_-N0LILHPEeS0dumc9hw2vw" name="Transport">
+      <fragment xmi:type="uml:MessageOccurrenceSpecification" xmi:id="_mr5HEMcGEeSZe4KIZH8Y5w" name="MessageSendTransportInstruction" message="_mrUfUMcGEeSZe4KIZH8Y5w"/>
+      <fragment xmi:type="uml:MessageOccurrenceSpecification" xmi:id="_mr5HEccGEeSZe4KIZH8Y5w" name="MessageRecvTransportInstruction" message="_mrUfUMcGEeSZe4KIZH8Y5w"/>
+      <fragment xmi:type="uml:CombinedFragment" xmi:id="_7POBMMcGEeSZe4KIZH8Y5w" name="isAccepted" covered="_Fd7iwLHQEeS0dumc9hw2vw _M52hwLHQEeS0dumc9hw2vw" interactionOperator="alt">
+        <operand xmi:type="uml:InteractionOperand" xmi:id="_7Pyo8McGEeSZe4KIZH8Y5w" name="InteractionOperand" covered="_Fd7iwLHQEeS0dumc9hw2vw _M52hwLHQEeS0dumc9hw2vw">
+          <guard xmi:type="uml:InteractionConstraint" xmi:id="_7P-2MMcGEeSZe4KIZH8Y5w" name="">
+            <specification xmi:type="uml:LiteralString" xmi:id="_7P-2MccGEeSZe4KIZH8Y5w" value="undefined"/>
+            <maxint xmi:type="uml:LiteralInteger" xmi:id="_7P-2M8cGEeSZe4KIZH8Y5w" value="1"/>
+            <minint xmi:type="uml:LiteralInteger" xmi:id="_7P-2MscGEeSZe4KIZH8Y5w"/>
+          </guard>
+        </operand>
+      </fragment>
+      <lifeline xmi:type="uml:Lifeline" xmi:id="_Fd7iwLHQEeS0dumc9hw2vw" name="LifelineMaterialSupplier" represents="_LGETMLEQEeSnYZTmeJXZKg" coveredBy="_7POBMMcGEeSZe4KIZH8Y5w _7Pyo8McGEeSZe4KIZH8Y5w"/>
+      <lifeline xmi:type="uml:Lifeline" xmi:id="_M52hwLHQEeS0dumc9hw2vw" name="LifelineTransport" represents="_944gMLEPEeSnYZTmeJXZKg" coveredBy="_7POBMMcGEeSZe4KIZH8Y5w _7Pyo8McGEeSZe4KIZH8Y5w"/>
+      <message xmi:type="uml:Message" xmi:id="_mrUfUMcGEeSZe4KIZH8Y5w" name="TransportInstruction" connector="_ZMBvALEVEeSnYZTmeJXZKg" messageSort="asynchCall" receiveEvent="_mr5HEccGEeSZe4KIZH8Y5w" sendEvent="_mr5HEMcGEeSZe4KIZH8Y5w" signature="_YGXBELENEeSnYZTmeJXZKg"/>
     </packagedElement>
     <packagedElement xmi:type="uml:Actor" xmi:id="_jPjZ8MGeEeSgpOzAzVFJPA" name="MaterialSupplier"/>
@@ -467,6 +484,4 @@
       <ownedAttribute xmi:type="uml:Property" xmi:id="_wgbOYMZlEeSM37Q-L6-vug" name="comments">
         <type xmi:type="uml:PrimitiveType" href="pathmap://UML_LIBRARIES/UMLPrimitiveTypes.library.uml#String"/>
-        <lowerValue xmi:type="uml:LiteralInteger" xmi:id="_cmyB8Mf7EeSpzN7smHOlWA"/>
-        <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_cmypAMf7EeSpzN7smHOlWA" value="*"/>
       </ownedAttribute>
       <ownedAttribute xmi:type="uml:Property" xmi:id="_wgbOYcZlEeSM37Q-L6-vug" name="accepted">
@@ -490,8 +505,8 @@
     <packagedElement xmi:type="uml:CallEvent" xmi:id="_Q2B48McEEeSZe4KIZH8Y5w" name="CallEventDropOffConfirmation" operation="_CMyFsLENEeSnYZTmeJXZKg"/>
     <packagedElement xmi:type="uml:CallEvent" xmi:id="_RAaukMcFEeSZe4KIZH8Y5w" name="CallEventFinalTransportStatusNotification" operation="_Wr1TUMGhEeSgpOzAzVFJPA"/>
-    <packagedElement xmi:type="uml:InterfaceRealization" xmi:id="_2NfKoMfgEeSpzN7smHOlWA" name="Realization0" client="_tXV18LEOEeSnYZTmeJXZKg" supplier="__m-9kLELEeSnYZTmeJXZKg" contract="__m-9kLELEeSnYZTmeJXZKg"/>
-    <packagedElement xmi:type="uml:InterfaceRealization" xmi:id="_2kn4QMfgEeSpzN7smHOlWA" name="Realization1" client="_o9UFMLEPEeSnYZTmeJXZKg" supplier="_wimi8LEMEeSnYZTmeJXZKg" contract="_wimi8LEMEeSnYZTmeJXZKg"/>
-    <packagedElement xmi:type="uml:InterfaceRealization" xmi:id="_29TeAMfgEeSpzN7smHOlWA" name="Realization2" client="_rU8q8LEPEeSnYZTmeJXZKg" supplier="_v3NckLEMEeSnYZTmeJXZKg" contract="_v3NckLEMEeSnYZTmeJXZKg"/>
-    <packagedElement xmi:type="uml:InterfaceRealization" xmi:id="_3fMDEMfgEeSpzN7smHOlWA" name="Realization3" client="_tDepULEPEeSnYZTmeJXZKg" supplier="_xI2DkLEMEeSnYZTmeJXZKg" contract="_xI2DkLEMEeSnYZTmeJXZKg"/>
+    <packagedElement xmi:type="uml:InterfaceRealization" xmi:id="_siE_kM1iEeSGIJvkDQlGlw" name="Realization0" client="_tXV18LEOEeSnYZTmeJXZKg" supplier="__m-9kLELEeSnYZTmeJXZKg" contract="__m-9kLELEeSnYZTmeJXZKg"/>
+    <packagedElement xmi:type="uml:InterfaceRealization" xmi:id="_0IL1UM1iEeSGIJvkDQlGlw" name="Realization1" client="_o9UFMLEPEeSnYZTmeJXZKg" supplier="_wimi8LEMEeSnYZTmeJXZKg" contract="_wimi8LEMEeSnYZTmeJXZKg"/>
+    <packagedElement xmi:type="uml:InterfaceRealization" xmi:id="_05fWcM1iEeSGIJvkDQlGlw" name="Realization2" client="_rU8q8LEPEeSnYZTmeJXZKg" supplier="_v3NckLEMEeSnYZTmeJXZKg" contract="_v3NckLEMEeSnYZTmeJXZKg"/>
+    <packagedElement xmi:type="uml:InterfaceRealization" xmi:id="_186iUM1iEeSGIJvkDQlGlw" name="Realization3" client="_tDepULEPEeSnYZTmeJXZKg" supplier="_xI2DkLEMEeSnYZTmeJXZKg" contract="_xI2DkLEMEeSnYZTmeJXZKg"/>
     <profileApplication xmi:type="uml:ProfileApplication" xmi:id="_Ca5hkLEKEeSnYZTmeJXZKg">
       <eAnnotations xmi:type="ecore:EAnnotation" xmi:id="_CbqWkLEKEeSnYZTmeJXZKg" source="http://www.eclipse.org/uml2/2.0.0/UML">
@@ -519,3 +534,4 @@
   <utp:SUT xmi:id="_LBHaYLETEeSnYZTmeJXZKg" base_Property="_HczmILETEeSnYZTmeJXZKg"/>
   <utp:TestComponent xmi:id="_-93ZALEUEeSnYZTmeJXZKg" base_StructuredClassifier="_hwwbELETEeSnYZTmeJXZKg"/>
+  <utp:TestCase xmi:id="_qXb2kLHPEeS0dumc9hw2vw" base_Operation="_k-fb8LHPEeS0dumc9hw2vw"/>
 </xmi:XMI>